#ifndef _PROTO_H_
#define _PROTO_H_

#define PROTOCOL_VERSION 0x0000001

#define MAX_GATEWAY_SIZE	50
#define MAX_KEY_SIZE		30

enum {
	VAR_NONE = 0,	/* null */
	VAR_VERSION,	/* number */
	VAR_COST,	/* number */
	VAR_GATEWAY,	/* string */
	VAR_LOOKUP,	/* string */
	VAR_STATUS,	/* number */
	VAR_REQUESTID,	/* number */
	VAR_INVALID,	/* number */
	VAR_DURATION,	/* number */
};

enum {
	FLAGS_NONE = 0x00,
	FLAGS_REQUEST = 0x01,
	FLAGS_RESPONSE = 0x02,
	FLAGS_BOTH = 0x03,
};

enum {
	REQ_TYPE_PING = 1,
	REQ_TYPE_PONG,
	REQ_TYPE_LOOKUP,
};

struct proto_header {
	int request_type;
};

struct proto_type {
	int id;
	int type;
	int len;
	int flags;
};

struct proto_type *lookup_type( int id );

#endif
