#ifndef _COMMON_H
#define _COMMON_H

#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>


#define MIN(x,y) ((x < y) ? x : y)

/**
 * Offset of an element within the struct
 */
#define offset_of(type, member)			\
	(unsigned long)&(((type *)0)->member)	\

/**
 * Pointer to the struct containing the given element
 */
#define container_of(ptr, type, member)				\
	(type *)((unsigned long)ptr - offset_of(type, member))	\


#ifdef __GNUC__
#define unlikely(expr)	__builtin_expect(!!(expr), 0)
#define likely(expr)	__builtin_expect(!!(expr), 1)
#else
#define unlikely(expr)	(expr)
#define likely(expr)	(expr)
#endif

#endif
